#include <stdio.h>
#include "mytypes.h"
#include "symdef.h"

SYMBOL symlist[MAX_SYM];
int symcount=0;

int symcmpa(void *s1, void *s2)
{
return ((SYMBOL *)s1)->addr-((SYMBOL *)s2)->addr;
}

SYMBOL *findsym(char *name,Word addr)
{
int i;
SYMBOL sym;

if (name==NULL)
  {
  sym.addr=addr;
  return (SYMBOL *)bsearch(&sym,symlist,symcount,sizeof(SYMBOL),symcmpa);
  }
for (i=0;i<symcount;i++)
  if (!strcasecmp(symlist[i].name,name))
    return &symlist[i];
return NULL;
}

int addsym(char *name,Word addr)
{
SYMBOL *sym;

sym=findsym(NULL,addr);

if (sym==NULL && symcount==MAX_SYM)
  return -1;
if (sym==NULL) {	
  sprintf(symlist[symcount].name,"%.15s",name);
  symlist[symcount++].addr=addr;
	}
else {
  sym->addr=addr;
  sprintf(sym->name,"%.15s",name);
	}
qsort(symlist,symcount,sizeof(SYMBOL),symcmpa);
return 0;
}

int delsym(char *name)
{
return 0;
}

char *symstr(Word addr)
{
SYMBOL *sym;
static char tmp[16];
if (sym=findsym(NULL,addr))
  return sym->name;
sprintf(tmp,"%04X",addr);
return tmp;
}

char *symstr2(Word addr)
{
SYMBOL *sym;
static char tmp[16];
if (sym=findsym(NULL,addr))
  return sym->name;
sprintf(tmp,"%02X",addr);
return tmp;
}

void printsym(Word addr)
{
SYMBOL *sym;
static char tmp[16];
if (sym=findsym(NULL,addr))
  printf("\n%s:\n",sym->name);
printf("%04X: ",addr);
}
